Erlang -- Inet Configuration

User's Guide
Reference Manual
Release Notes
PDF
Top

Erlang Run-Time System Application (ERTS)
User's Guide
Version 8.2

Expand All
Contract All

Chapters

- Introduction
  - Top of chapter
  - Scope
  - Prerequisites
- Communication in Erlang
  - Top of chapter
  - Passing of Signals
  - Synchronous Communication
  - Implementation
- Time and Time Correction in Erlang
  - Top of chapter
  - New Extended Time Functionality
  - Terminology
  - Introduction
  - Time Correction
  - Time Warp Safe Code
  - Time Warp Modes
  - New Time API
  - Support of Both New and Old OTP Releases
- Match Specifications in Erlang
  - Top of chapter
  - Grammar
  - Function Descriptions
  - Match target
  - Variables and Literals
  - Execution of the Match
  - Differences between Match Specifications in ETS and Tracing
  - Tracing Examples
  - ETS Examples
- How to Interpret the Erlang Crash Dumps
  - Top of chapter
  - General Information
  - Scheduler Information
  - Memory Information
  - Internal Table Information
  - Allocated Areas
  - Allocator
  - Process Information
  - Port Information
  - ETS Tables
  - Timers
  - Distribution Information
  - Loaded Module Information
  - Fun Information
  - Process Data
  - Atoms
  - Disclaimer
- How to Implement an Alternative Carrier for the Erlang Distribution
  - Top of chapter
  - Introduction
  - The Driver
  - Putting It All Together
- The Abstract Format
  - Top of chapter
  - Module Declarations and Forms
  - Atomic Literals
  - Patterns
  - Expressions
  - Clauses
  - Guards
  - Types
  - The Abstract Format after Preprocessing
- tty - A Command-Line Interface
  - Top of chapter
  - Normal Mode
  - Shell Break Mode
- How to Implement a Driver
  - Top of chapter
  - Introduction
  - Sample Driver
  - Compiling and Linking the Sample Driver
  - Calling a Driver as a Port in Erlang
  - Sample Asynchronous Driver
  - An Asynchronous Driver Using driver_async
- Inet Configuration
  - Top of chapter
  - Introduction
  - Configuration Data
  - User Configuration Example
- External Term Format
  - Top of chapter
  - Introduction
  - Distribution Header
  - ATOM_CACHE_REF
  - SMALL_INTEGER_EXT
  - INTEGER_EXT
  - FLOAT_EXT
  - ATOM_EXT
  - REFERENCE_EXT
  - PORT_EXT
  - PID_EXT
  - SMALL_TUPLE_EXT
  - LARGE_TUPLE_EXT
  - MAP_EXT
  - NIL_EXT
  - STRING_EXT
  - LIST_EXT
  - BINARY_EXT
  - SMALL_BIG_EXT
  - LARGE_BIG_EXT
  - NEW_REFERENCE_EXT
  - SMALL_ATOM_EXT
  - FUN_EXT
  - NEW_FUN_EXT
  - EXPORT_EXT
  - BIT_BINARY_EXT
  - NEW_FLOAT_EXT
  - ATOM_UTF8_EXT
  - SMALL_ATOM_UTF8_EXT
- Distribution Protocol
  - Top of chapter
  - EPMD Protocol
  - Distribution Handshake
  - Protocol between Connected Nodes
  - New Ctrlmessages for distrvsn = 1 (Erlang/OTP R4)
  - New Ctrlmessages for distrvsn = 2
  - New Ctrlmessages for distrvsn = 3 (Erlang/OTP R5C)
  - New Ctrlmessages for distrvsn = 4 (Erlang/OTP R6)

# 10 Inet Configuration

### 10.1 Introduction

This section describes how the Erlang runtime system is configured for IP communication. It also explains how you can configure it for your needs by a configuration file. The information is primarily intended for users with special configuration needs or problems. There is normally no need for specific settings for Erlang to function properly on a correctly IP-configured platform.

When Erlang starts up it reads the Kernel variable inetrc, which, if defined, is to specify the location and name of a user configuration file. Example:

    % erl -kernel inetrc '"./cfg_files/erl_inetrc"'

Notice that the use of an .inetrc file, which was supported in earlier Erlang/OTP versions, is now obsolete.

A second way to specify the configuration file is to set environment variable ERL_INETRC to the full name of the file. Example (bash):

    % export ERL_INETRC=./cfg_files/erl_inetrc

Notice that the Kernel variable inetrc overrides this environment variable.

If no user configuration file is specified and Erlang is started in non-distributed or short name distributed mode, Erlang uses default configuration settings and a native lookup method that works correctly under most circumstances. Erlang reads no information from system inet configuration files (such as /etc/host.conf and /etc/nsswitch.conf) in these modes, except for /etc/resolv.conf and /etc/hosts that is read and monitored for changes on Unix platforms for the internal DNS client inet_res(3).

If Erlang is started in long name distributed mode, it needs to get the domain name from somewhere and reads system inet configuration files for this information. Any hosts and resolver information found is also recorded, but not used as long as Erlang is configured for native lookups. The information becomes useful if the lookup method is changed to 'file' or 'dns', see below.

Native lookup (system calls) is always the default resolver method. This is true for all platforms, except VxWorks and OSE Delta where 'file' or 'dns' is used (in that priority order).

On Windows platforms, Erlang searches the system registry rather than looks for configuration files when started in long name distributed mode.

### 10.2 Configuration Data

Erlang records the following data in a local database if found in system inet configuration files (or system registry):

- Hostnames and host addresses
- Domain name
- Nameservers
- Search domains
- Lookup method

This data can also be specified explicitly in the user configuration file. This file is to contain lines of configuration parameters (each terminated with a full stop). Some parameters add data to the configuration (such as host and nameserver), others overwrite any previous settings (such as domain and lookup). The user configuration file is always examined last in the configuration process, making it possible for the user to override any default values or previously made settings. Call inet:get_rc() to view the state of the inet configuration database.

The valid configuration parameters are as follows:

{file, Format, File}.

  Format = atom()

  File = string()

  Specify a system file that Erlang is to read configuration data from. Format tells the parser how the file is to be interpreted:

  - resolv (Unix resolv.conf)
  - host_conf_freebsd (FreeBSD host.conf)
  - host_conf_bsdos (BSDOS host.conf)
  - host_conf_linux (Linux host.conf)
  - nsswitch_conf (Unix nsswitch.conf)
  - hosts (Unix hosts)

  File is to specify the filename with full path.

{resolv_conf, File}.

  File = string()

  Specify a system file that Erlang is to read resolver configuration from for the internal DNS client inet_res(3), and monitor for changes, even if it does not exist. The path must be absolute.

  This can override the configuration parameters nameserver and search depending on the contents of the specified file. They can also change any time in the future reflecting the file contents.

  If the file is specified as an empty string "", no file is read or monitored in the future. This emulates the old behavior of not configuring the DNS client when the node is started in short name distributed mode.

  If this parameter is not specified, it defaults to /etc/resolv.conf unless environment variable ERL_INET_ETC_DIR is set, which defines the directory for this file to some maybe other than /etc.

{hosts_file, File}.

  File = string()

  Specify a system file that Erlang is to read resolver configuration from for the internal hosts file resolver, and monitor for changes, even if it does not exist. The path must be absolute.

  These host entries are searched after all added with {file, hosts, File} above or {host, IP, Aliases} below when lookup option file is used.

  If the file is specified as an empty string "", no file is read or monitored in the future. This emulates the old behavior of not configuring the DNS client when the node is started in short name distributed mode.

  If this parameter is not specified, it defaults to /etc/hosts unless environment variable ERL_INET_ETC_DIR is set, which defines the directory for this file to some maybe other than /etc.

{registry, Type}.

  Type = atom()

  Specify a system registry that Erlang is to read configuration data from. win32 is the only valid option.

{host, IP, Aliases}.

  IP = tuple()

  Aliases = [string()]

  Add host entry to the hosts table.

{domain, Domain}.

  Domain = string()

  Set domain name.

{nameserver, IP [,Port]}.

  IP = tuple()

  Port = integer()

  Add address (and port, if other than default) of the primary nameserver to use for inet_res(3).

{alt_nameserver, IP [,Port]}.

  IP = tuple()

  Port = integer()

  Add address (and port, if other than default) of the secondary nameserver for inet_res(3).

{search, Domains}.

  Domains = [string()]

  Add search domains for inet_res(3).

{lookup, Methods}.

  Methods = [atom()]

  Specify lookup methods and in which order to try them. The valid methods are as follows:

  - native (use system calls)
  - file (use host data retrieved from system configuration files and/or the user configuration file)
  - dns (use the Erlang DNS client inet_res(3) for nameserver queries)

  The lookup method string tries to parse the hostname as an IPv4 or IPv6 string and return the resulting IP address. It is automatically tried first when native is not in the Methods list. To skip it in this case, the pseudo lookup method nostring can be inserted anywhere in the Methods list.

{cache_size, Size}.

  Size = integer()

  Set the resolver cache size. Defaults to 100 DNS records.

{cache_refresh, Time}.

  Time = integer()

  Set how often (in milliseconds) the resolver cache for inet_res(3) is refreshed (that is, expired DNS records are deleted). Defaults to 1 hour.

{timeout, Time}.

  Time = integer()

  Set the time to wait until retry (in milliseconds) for DNS queries made by inet_res(3). Defaults to 2 seconds.

{retry, N}.

  N = integer()

  Set the number of DNS queries inet_res(3) will try before giving up. Defaults to 3.

{inet6, Bool}.

  Bool = true | false

  Tells the DNS client inet_res(3) to look up IPv6 addresses. Defaults to false.

{usevc, Bool}.

  Bool = true | false

  Tells the DNS client inet_res(3) to use TCP (Virtual Circuit) instead of UDP. Defaults to false.

{edns, Version}.

  Version = false | 0

  Sets the EDNS version that inet_res(3) will use. The only allowed version is zero. Defaults to false, which means not to use EDNS.

{udp_payload_size, Size}.

  N = integer()

  Sets the allowed UDP payload size inet_res(3) will advertise in EDNS queries. Also sets the limit when the DNS query will be deemed too large for UDP forcing a TCP query instead; this is not entirely correct, as the advertised UDP payload size of the individual nameserver is what is to be used, but this simple strategy will do until a more intelligent (probing, caching) algorithm needs to be implemented. Default to 1280, which stems from the standard Ethernet MTU size.

{udp, Module}.

  Module = atom()

  Tell Erlang to use another primitive UDP module than inet_udp.

{tcp, Module}.

  Module = atom()

  Tell Erlang to use another primitive TCP module than inet_tcp.

clear_hosts.

  Clear the hosts table.

clear_ns.

  Clear the list of recorded nameservers (primary and secondary).

clear_search.

  Clear the list of search domains.

### 10.3 User Configuration Example

Assume that a user does not want Erlang to use the native lookup method, but wants Erlang to read all information necessary from start and use that for resolving names and addresses. If lookup fails, Erlang is to request the data from a nameserver (using the Erlang DNS client, set to use EDNS allowing larger responses). The resolver configuration is updated when its configuration file changes. Also, DNS records are never to be cached. The user configuration file (in this example named erl_inetrc, stored in directory ./cfg_files) can then look as follows (Unix):

    %% -- ERLANG INET CONFIGURATION FILE --
    %% read the hosts file
    {file, hosts, "/etc/hosts"}.
    %% add a particular host
    {host, {134,138,177,105}, ["finwe"]}.
    %% do not monitor the hosts file
    {hosts_file, ""}.
    %% read and monitor nameserver config from here
    {resolv_conf, "/usr/local/etc/resolv.conf"}.
    %% enable EDNS
    {edns,0}.
    %% disable caching
    {cache_size, 0}.
    %% specify lookup method
    {lookup, [file, dns]}.

And Erlang can, for example, be started as follows:

    % erl -sname my_node -kernel inetrc '"./cfg_files/erl_inetrc"'